#ifndef ABILITIES_H
#define ABILITIES_H

#include <string>
using namespace std;

class player_character;

class Ability {
	
	public:
		int cost;
		int cooldown;
		int damage_modifier;
		int last_use;
		int damage;
		int range;
		std::string name;
	
	public:
	
		void set_cost(int i)
		{cost=i;}
		
		void set_cooldown(int i)
		{cooldown=i;}
		
		void set_damage_modifier(int i)
		{damage_modifier=i;}
		
		void set_name(string new_name)
		{name = new_name;}
		
		virtual void Initialize(int ap_cost, int turn_cool, int modifier, int max_range, string name) = 0;
		
		virtual int effect(player_character &player)
		{return 0;}
};

class Cleave: public Ability{
	
	public:
		int effect(player_character &player){
			
			damage=player.ReturnAttack()*damage_modifier;
			
			return damage;
			
		}
		
		void Initialize(int ap_cost, int turn_cool, int modifier, int max_range, string new_name)
		{
			cost = ap_cost;
			cooldown = turn_cool;
			damage_modifier = modifier;
			name = new_name;
			range = max_range;
		}
};
			

/*class Fireblast: public Ability{

	public:
		int effect(player_character &player){
			
			damage=(player.WILL*3)*damage_modifier;
			
			return damage;
			
		}
		
};

class Backstab: public Ability{
	
	public:
		int effect(player_character &player){
			
		//	if (current_enemies[target].player_orientation=="back"){
				
				damage=player.ATTACK*(damage_modifier);
				
			//}
			//else {
				
				damage=player.ATTACK;
				
			//}
			
			return damage;
			
		}
		
};*/
	
#endif /* ABILITIES_H */