#include "armours.h"

Armour::Armour(std::string Name, 
				int STR, 
				int DEX, 
				int WILL, 
				int VIT, 
				int PROTECT, 
				int CARRY, 
				int HP)
{
	name=Name;
	STR_MODIFIER=STR;
	DEX_MODIFIER=DEX;
	WILL_MODIFIER=WILL;
	VIT_MODIFIER=VIT;
	PROTECTION=PROTECT;
	CARRY_MODIFIER=CARRY;
	HP_MODIFIER=HP;
}
	

void AddToArmourList(
				std::string name, 
				int STR_MODIFIER, 
				int DEX_MODIFIER, 
				int WILL_MODIFIER, 
				int VIT_MODIFIER, 
				int PROTECTION, 
				int CARRY_MODIFIER, 
				int HP_MODIFIER,
				std::vector<Armour>& armour_list)
				
{

	Armour armour (
					name, 
					STR_MODIFIER, 
					DEX_MODIFIER, 
					WILL_MODIFIER, 
					VIT_MODIFIER,  
					PROTECTION, 
					CARRY_MODIFIER, 
					HP_MODIFIER
				);

	armour_list.push_back(armour);
	
}

void createArmourList(std::vector<Armour>& armour_list){
	
	AddToArmourList(
					"Iron Armour",
					0,
					-1,
					0,
					0,
					20,
					0,
					0,
					armour_list
				);
		
	AddToArmourList(
					"Fur Armour",
					0,
					0,
					0,
					0,
					10,
					0,
					0,
					armour_list
				);
				
	AddToArmourList(
					"Cloth Robe",
					0,
					0,
					1,
					0,
					5,
					0,
					0,
					armour_list
				);
					
		
	
}