#ifndef MUSIC_H
#define MUSIC_H
//remember to include "notes.h" and "music.h" at the start of the main program

#include <string>

struct playNote {
	std::string notepitch; //the musical name for the note you want to play
	short notelength; //self explanatory - 1 being a quaver
};

const int musicLength=16; //self explanatory - REMEMBER TO INCLUDE RESTS! - Generally best to write the array then enter this value

//Example of how to lay out a music array - entries with no note name are rests

const playNote dungeonTune[musicLength] = {
	{
		"C3",2,
	},
	{
		"G3",2,
	},
	{
		"B3",2,
	},
	{
		"F#3",2,
	},
	{
		"C3",2,
	},
	{
		"G3",2,
	},
	{
		"A#3",2,
	},
	{
		"F#3",2,
	},
	{
		"C3",2,
	},
	{
		"G3",2,
	},
	{
		"B3",2,
	},
	{
		"F#3",2,
	},
	{
		"C3",2,
	},
	{
		"G3",2,
	},
	{
		"C4",2,
	},
	{
		"F#3",2,
	},
};


#endif