#include "weapons.h"


Weapon::Weapon(
				std::string Name, 
				classes weapon,
				int STR, 
				int DEX, 
				int WILL, 
				int VIT, 
				int ATTACK, 
				int PROTECT, 
				int CARRY, 
				int HP)
{
	name=Name;
	weapon_class=weapon;
	STR_MODIFIER=STR;
	DEX_MODIFIER=DEX;
	WILL_MODIFIER=WILL;
	VIT_MODIFIER=VIT;
	ATTACK_POWER=ATTACK;
	PROTECTION=PROTECT;
	CARRY_MODIFIER=CARRY;
	HP_MODIFIER=HP;
}

void AddToWeaponList(
				std::string name, 
				classes weapon_class,
				int STR_MODIFIER, 
				int DEX_MODIFIER, 
				int WILL_MODIFIER, 
				int VIT_MODIFIER, 
				int ATTACK_POWER, 
				int PROTECTION, 
				int CARRY_MODIFIER, 
				int HP_MODIFIER, 
				std::vector<Weapon>& weapon_list)
				
{

	Weapon weapon (
					name, 
					weapon_class,
					STR_MODIFIER, 
					DEX_MODIFIER, 
					WILL_MODIFIER, 
					VIT_MODIFIER, 
					ATTACK_POWER, 
					PROTECTION, 
					CARRY_MODIFIER, 
					HP_MODIFIER
				);

	weapon_list.push_back(weapon);
	
}
				
void createWeaponList(std::vector<Weapon>& weapon_list){
	
	AddToWeaponList(
					"Shortsword",
					classes::Warrior,
					0,
					0,
					0,
					0,
					15,
					0,
					0,
					0,
					weapon_list);
					
	AddToWeaponList(
					"Shiv",
					classes::Rogue,
					0,
					0,
					0,
					0,
					7,
					0,
					0,
					0,
					weapon_list);
	
	AddToWeaponList(
					"Wooden Staff",
					classes::Mage,
					0,
					0,
					0,
					0,
					5,
					0,
					0,
					0,
					weapon_list);
					
}
			
					
					

		