#ifndef WEAPONS_H
#define WEAPONS_H

#include <string>
#include <vector>

enum class classes{Warrior, Rogue, Mage};

class Weapon {

	public:
		
		std::string name;
		classes weapon_class;
		
		int 
			STR_MODIFIER, 
			DEX_MODIFIER,
			WILL_MODIFIER,
			VIT_MODIFIER,
			ATTACK_POWER,
			PROTECTION,
			CARRY_MODIFIER,
			HP_MODIFIER
		;
		
		Weapon(
				std::string Name, 
				classes weapon,
				int STR, 
				int DEX, 
				int WILL, 
				int VIT, 
				int ATTACK, 
				int PROTECT, 
				int CARRY, 
				int HP);
		
};

void createWeaponList(std::vector<Weapon>& weapon_list);

		
#endif /* WEAPONS_H */